{****************************************************************
 ****************************************************************
 ***           This file belongs to PVIEW/PSKILL              ***
 ***        Copyright (c) 2001 by -=Assarbad [GoP]=-          ***
 ***       ____________                 ___________           ***
 ***      /\   ________\               /\   _____  \          ***
 ***     /  \  \       /    __________/  \  \    \  \         ***
 ***     \   \  \   __/___ /\   _____  \  \  \____\  \        ***
 ***      \   \  \ /\___  \  \  \    \  \  \   _______\       ***
 ***       \   \  \ /   \  \  \  \    \  \  \  \      /       ***
 ***        \   \  \_____\  \  \  \____\  \  \  \____/        ***
 ***         \   \___________\  \__________\  \__\            ***
 ***          \  /           /  /          /  /  /            ***
 ***           \/___________/ \/__________/ \/__/             ***
 ***                                                          ***
 ***  May the source be with you, stranger ... :-)            ***
 ***                                                          ***
 ***  Greets from -=Assarbad [GoP]=- ...                      ***
 ***  Special greets go 2 Nico, Casper, SA, Pizza, Navarion...***
 ***[for questions/proposals drop a mail to Assarbad@ePost.de]***
 *****************************************ASCII by Assa [GoP]****
 ****************************************************************}

PROGRAM pview;
USES windows,
    messages,
    sysutils;

{$DEFINE INCLUDE_9X}

CONST
    windowheight:integer=170;
    windowwidth:integer=288;
    windowleft:integer=100;
    windowtop:integer=100;
    classname='AssaPViewWndClass';
    IDC_BUTTON1=1001;//Refresh
    IDC_BUTTON2=1002;//Kill
    IDC_BUTTON3=1003;//Close
    IDC_BUTTON4=1004;//Remote
    IDC_LIST1=1005;//listbox
    IDC_CHECK1=1006;//force kill
    IDC_EDIT1=1007;//edit for remote box
    SE_DEBUG_NAME='SeDebugPrivilege';
    runonNT:boolean=false;
    err='Error';
    err_notkilled='The process could not be killed.';
    err_gotnopriv='Failed to get the debug privilege.';
    err_nosel='Select an item first.';
    err_noOS='The OS version could not be determined. Quitting.';
{$IFNDEF INCLUDE_9X}
    err_onlyNT='This is only a Window NT version';
{$ENDIF}
    progname='PVIEW  2001 by -=Assarbad=-';

{$R main.res}
{$INCLUDE NTPROC.PAS}

{$IFDEF INCLUDE_9X}
  {$INCLUDE 9xPROC.PAS}
{$ENDIF}

{DEFINE TIMERON}//not defined!
VAR
    hdlg:DWORD=0;
{$IFDEF TIMERON}
    mytimer:DWORD;
{$ENDIF}

FUNCTION dlgproc(hwnd:hwnd;imsg:dword;wparam:wparam;lparam:lparam):bool; STDCALL;
VAR
    fixedfont:DWORD;
BEGIN
    result:=true;
    CASE imsg OF
        WM_INITDIALOG:
            BEGIN
                CheckDlgButton(hwnd, IDC_CHECK1, BST_CHECKED);
                fixedfont:=CreateFont(-MulDiv(6, GetDeviceCaps(GetWindowDC(hwnd), LOGPIXELSY), 72), 0, 0, 0, FW_NORMAL, 0, 0, 0, ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH OR FF_MODERN, 'Courier');
                sendmessage(Getdlgitem(hwnd, IDC_LIST1), WM_SETFONT, fixedfont, LongInt(TRUE));
            END;
        WM_COMMAND:
            sendmessage(getparent(hwnd), imsg, wparam, lparam);
    ELSE result:=false;
    END;
END;

FUNCTION SetPrivilege(sPrivilegeName:STRING;bEnabled:boolean):boolean;
VAR
    TPPrev, TP:TTokenPrivileges;
    Token:THandle;
    dwRetLen:DWord;
BEGIN
    Result:=False;
    OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES OR TOKEN_QUERY, Token);
    TP.PrivilegeCount:=1;
    IF LookupPrivilegeValue(NIL, PChar(sPrivilegeName), TP.Privileges[0].LUID) THEN BEGIN
        IF (bEnabled) THEN
            TP.Privileges[0].Attributes:=SE_PRIVILEGE_ENABLED
        ELSE
            TP.Privileges[0].Attributes:=0;
        dwRetLen:=0;
        Result:=AdjustTokenPrivileges(Token, False, TP, SizeOf(TPPrev), TPPrev, dwRetLen);
    END;
    CloseHandle(Token);
END;

FUNCTION KillProcess(PID:DWORD):boolean;
VAR
    hProcess:DWORD;
BEGIN
    result:=false;
    CASE runonNT OF
        TRUE:
            IF NOT SetPrivilege(SE_DEBUG_NAME, true) THEN BEGIN
                messagebox(0, err_gotnopriv, err, MB_OK);
                exit;
            END;
    END;
    hProcess:=OpenProcess(PROCESS_ALL_ACCESS, FALSE, PID);
    IF hProcess=0 THEN exit;
    result:=BOOL(TerminateProcess(hProcess, 1));
    CloseHandle(hProcess);
END;

PROCEDURE Refreshlist(hwnd:hwnd);
VAR
    processes:TProcessrecs;
    i:integer;
BEGIN
    setlength(processes, 0);
    CASE runonNT OF
        TRUE:processes:=GetProcessesNT;
{$IFDEF INCLUDE_9X}
        FALSE:processes:=GetProcesses9x;
{$ENDIF}
    END;
    sendmessage(hwnd, LB_RESETCONTENT, 0, 0);
    FOR i:=0 TO length(processes)-1 DO BEGIN
        sendmessage(hwnd, LB_ADDSTRING, 0, LongInt(pchar(frmt('%8.8X - %s', [pointer(processes[i].PID), pchar(processes[i].name)]))));
    END;
//select first entry as standard selection
    sendmessage(hwnd, LB_SETCURSEL, 0, 0);
END;

FUNCTION WndProc(hWnd:HWND;uMsg:UINT;wParam:WPARAM;lParam:LPARAM):LRESULT; STDCALL;
VAR
    index:integer;
    text:pchar;
    text2:STRING;
BEGIN
    Result:=0;
    CASE uMsg OF
        WM_CREATE:
            BEGIN
                HDLG:=CreateDialog(0, MAKEINTRESOURCE(101), hwnd, @dlgproc);
                refreshlist(Getdlgitem(hdlg, IDC_LIST1));
{$IFDEF TIMERON}
                mytimer:=SetTimer(hWnd, 1, 10000, NIL);
{$ENDIF}
            END;
        WM_DESTROY:
            BEGIN
                PostQuitMessage(0);
{$IFDEF TIMERON}
                KillTimer(hWnd, mytimer);
{$ENDIF}
                enddialog(HDLG, 0);
            END;
{$IFDEF TIMERON}
        WM_TIMER:
            BEGIN
                refreshlist(Getdlgitem(hdlg, IDC_LIST1));
            END;
{$ENDIF}
        WM_COMMAND:
            IF hiword(wparam)=BN_CLICKED THEN BEGIN
                CASE loword(wparam) OF
                    IDC_BUTTON1://refresh
                        refreshlist(Getdlgitem(hdlg, IDC_LIST1));
                    IDC_BUTTON2://kill
                        BEGIN
                            index:=sendmessage(getdlgitem(hdlg, IDC_LIST1), LB_GETCURSEL, 0, 0);
                            IF index<>LB_ERR THEN BEGIN
                                getmem(text, 1024);
                                sendmessage(getdlgitem(hdlg, IDC_LIST1), LB_GETTEXT, LongInt(index), LongInt(text));
                                text2:=text;
                                text2:='$'+copy(text2, 1, 8);
                                freemem(text);
                                if not killprocess(strtoint(text2)) then
                                   messagebox(hwnd, err_notkilled, err, MB_OK);;
                            END ELSE messagebox(hwnd, err_nosel, err, MB_OK);
                        END;
                    IDC_BUTTON3://close
                        sendmessage(hwnd, wm_syscommand, SC_CLOSE, 0);
                END;
            END;
    ELSE
        Result:=DefWindowProc(hWnd, uMsg, wParam, lParam);
    END;
END;

VAR
    wc:TWndClassEx=(
        cbSize:SizeOf(TWndClassEx);
        style:CS_OWNDC OR CS_HREDRAW OR CS_VREDRAW;
        cbClsExtra:0;
        cbWndExtra:0;
        hbrBackground:COLOR_WINDOW;
        lpszMenuName:NIL;
        lpszClassName:ClassName;
        hIconSm:0;);
    msg:TMSG;
    rect:trect;
    deskh, deskw:integer;
    osinfo:TOSVERSIONinfo;
BEGIN
    osinfo.dwOSVersionInfoSize:=sizeof(TOSVERSIONinfo);
    IF NOT BOOL(GetVersionEx(osinfo)) THEN BEGIN
        messagebox(0, err_noOS, err, MB_OK);
        halt($FF);
    END ELSE runonNT:=osinfo.dwPlatformId=VER_PLATFORM_WIN32_NT;
{$IFNDEF INCLUDE_9X}
    IF NOT runonNT THEN BEGIN
        messagebox(0, err_onlyNT, err, MB_OK);
        halt($FE);
    END;
{$ENDIF}
    wc.hInstance:=HInstance;
    wc.hIcon:=LoadIcon(HInstance, MAKEINTRESOURCE(1));
    wc.hCursor:=LoadCursor(0, IDC_ARROW);
    wc.lpfnWndProc:=@WndProc;
    systemparametersinfo(SPI_GETWORKAREA, 0, @rect, 0);
    deskw:=rect.Right-rect.Left;
    deskh:=rect.Bottom-rect.Top;
    windowwidth:=windowleft+windowwidth;
    windowheight:=windowtop+windowheight;
    Windowleft:=(deskw DIV 2)-(windowwidth DIV 2);
    Windowtop:=(deskh DIV 2)-(windowheight DIV 2);
    RegisterClassEx(wc);
    CreateWindowEx(WS_EX_WINDOWEDGE OR WS_EX_CONTROLPARENT OR WS_EX_APPWINDOW,
        ClassName,
        progname,
        WS_OVERLAPPED
        OR WS_CAPTION
        OR WS_SYSMENU
        OR WS_MINIMIZEBOX
        OR WS_VISIBLE,
        windowleft,
        windowtop,
        windowwidth,
        windowheight,
        0,
        0,
        hInstance,
        NIL);
    WHILE True DO BEGIN
        IF NOT GetMessage(msg, 0, 0, 0) THEN break;//oops :o)
        IF hdlg<>0 THEN
            IF isdialogmessage(hdlg, msg) THEN continue;
        translatemessage(msg);
        dispatchmessage(msg);
    END;
    ExitCode:=GetLastError;
END.
